/* Copyright (c) 2009 ActiveState
   See the file LICENSE.txt for licensing information. */

/**
 * This is an XPCOM wrapper the JavaScript (npruntime) scimoz object:
 */

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

/***********************************************************
 *              XPCOM class definition                     *
 ***********************************************************/

// Class constructor.
function koSciMozWrapper() {
    this.wrappedJSObject = this;
}

// Class definition.
koSciMozWrapper.prototype = {

    // properties required for XPCOM registration:
    classDescription: "XPCOM wrapper around the npruntime scimoz object",

    classID:          Components.ID("{487f68c7-386a-4802-8874-b0f4912e59dc}"),
    contractID:       "@activestate.com/koSciMozWrapper;1",

    _interfaces: [Components.interfaces.nsIClassInfo,
                  Components.interfaces.ISciMozLite,
                  Components.interfaces.ISciMoz,
                  Components.interfaces.nsISupportsWeakReference],
    /* see bottom of file for QI impl */

    getInterfaces: function getInterfaces(aCount) {
        aCount.value = this._interfaces.length;
        return Array.slice(this._interfaces);
    },

    getHelperForLanguage: function() null,
    implementationLanguage: Components.interfaces.nsIProgrammingLanguage.JAVASCRIPT,
    flags: Components.interfaces.nsIClassInfo.MAIN_THREAD_ONLY |
           Components.interfaces.nsIClassInfo.EAGER_CLASSINFO,

    __scimoz: null,
};

koSciMozWrapper.prototype._interfaces.push(Components.interfaces.ISciMoz_Part0);
koSciMozWrapper.prototype._interfaces.push(Components.interfaces.ISciMoz_Part1);
koSciMozWrapper.prototype._interfaces.push(Components.interfaces.ISciMoz_Part2);
koSciMozWrapper.prototype._interfaces.push(Components.interfaces.ISciMoz_Part3);
koSciMozWrapper.prototype.__defineGetter__("highlightGuide",
                                           function()this.__scimoz.highlightGuide);
koSciMozWrapper.prototype.__defineGetter__("edgeColumn",
                                           function()this.__scimoz.edgeColumn);
koSciMozWrapper.prototype.__defineGetter__("twoPhaseDraw",
                                           function()this.__scimoz.twoPhaseDraw);
koSciMozWrapper.prototype.__defineGetter__("endStyled",
                                           function()this.__scimoz.endStyled);
koSciMozWrapper.prototype.__defineGetter__("focus",
                                           function()this.__scimoz.focus);
koSciMozWrapper.prototype.__defineGetter__("autoCMaxHeight",
                                           function()this.__scimoz.autoCMaxHeight);
koSciMozWrapper.prototype.__defineGetter__("autoCCancelAtStart",
                                           function()this.__scimoz.autoCCancelAtStart);
koSciMozWrapper.prototype.__defineGetter__("rectangularSelectionAnchor",
                                           function()this.__scimoz.rectangularSelectionAnchor);
koSciMozWrapper.prototype.__defineGetter__("multipleSelection",
                                           function()this.__scimoz.multipleSelection);
koSciMozWrapper.prototype.__defineGetter__("selText",
                                           function()this.__scimoz.selText);
koSciMozWrapper.prototype.__defineGetter__("indicatorValue",
                                           function()this.__scimoz.indicatorValue);
koSciMozWrapper.prototype.__defineGetter__("text",
                                           function()this.__scimoz.text);
koSciMozWrapper.prototype.__defineGetter__("annotationStyleOffset",
                                           function()this.__scimoz.annotationStyleOffset);
koSciMozWrapper.prototype.__defineGetter__("bufferedDraw",
                                           function()this.__scimoz.bufferedDraw);
koSciMozWrapper.prototype.__defineGetter__("whitespaceSize",
                                           function()this.__scimoz.whitespaceSize);
koSciMozWrapper.prototype.__defineGetter__("hScrollBar",
                                           function()this.__scimoz.hScrollBar);
koSciMozWrapper.prototype.__defineGetter__("readOnly",
                                           function()this.__scimoz.readOnly);
koSciMozWrapper.prototype.__defineGetter__("keysUnicode",
                                           function()this.__scimoz.keysUnicode);
koSciMozWrapper.prototype.__defineGetter__("selEOLFilled",
                                           function()this.__scimoz.selEOLFilled);
koSciMozWrapper.prototype.__defineGetter__("name",
                                           function()this.__scimoz.name);
koSciMozWrapper.prototype.__defineGetter__("overtype",
                                           function()this.__scimoz.overtype);
koSciMozWrapper.prototype.__defineGetter__("lexer",
                                           function()this.__scimoz.lexer);
koSciMozWrapper.prototype.__defineGetter__("codePage",
                                           function()this.__scimoz.codePage);
koSciMozWrapper.prototype.__defineGetter__("zoom",
                                           function()this.__scimoz.zoom);
koSciMozWrapper.prototype.__defineGetter__("selections",
                                           function()this.__scimoz.selections);
koSciMozWrapper.prototype.__defineGetter__("selectionIsRectangle",
                                           function()this.__scimoz.selectionIsRectangle);
koSciMozWrapper.prototype.__defineGetter__("rectangularSelectionAnchorVirtualSpace",
                                           function()this.__scimoz.rectangularSelectionAnchorVirtualSpace);
koSciMozWrapper.prototype.__defineGetter__("indentationGuides",
                                           function()this.__scimoz.indentationGuides);
koSciMozWrapper.prototype.__defineGetter__("autoCIgnoreCase",
                                           function()this.__scimoz.autoCIgnoreCase);
koSciMozWrapper.prototype.__defineGetter__("identifier",
                                           function()this.__scimoz.identifier);
koSciMozWrapper.prototype.__defineGetter__("useTabs",
                                           function()this.__scimoz.useTabs);
koSciMozWrapper.prototype.__defineGetter__("printColourMode",
                                           function()this.__scimoz.printColourMode);
koSciMozWrapper.prototype.__defineGetter__("hotspotSingleLine",
                                           function()this.__scimoz.hotspotSingleLine);
koSciMozWrapper.prototype.__defineGetter__("vScrollBar",
                                           function()this.__scimoz.vScrollBar);
koSciMozWrapper.prototype.__defineGetter__("directFunction",
                                           function()this.__scimoz.directFunction);
koSciMozWrapper.prototype.__defineGetter__("endAtLastLine",
                                           function()this.__scimoz.endAtLastLine);
koSciMozWrapper.prototype.__defineGetter__("mainSelection",
                                           function()this.__scimoz.mainSelection);
koSciMozWrapper.prototype.__defineGetter__("selectionStart",
                                           function()this.__scimoz.selectionStart);
koSciMozWrapper.prototype.__defineGetter__("wrapStartIndent",
                                           function()this.__scimoz.wrapStartIndent);
koSciMozWrapper.prototype.__defineGetter__("directPointer",
                                           function()this.__scimoz.directPointer);
koSciMozWrapper.prototype.__defineGetter__("undoCollection",
                                           function()this.__scimoz.undoCollection);
koSciMozWrapper.prototype.__defineGetter__("viewEOL",
                                           function()this.__scimoz.viewEOL);
koSciMozWrapper.prototype.__defineGetter__("edgeColour",
                                           function()this.__scimoz.edgeColour);
koSciMozWrapper.prototype.__defineGetter__("wrapVisualFlags",
                                           function()this.__scimoz.wrapVisualFlags);
koSciMozWrapper.prototype.__defineGetter__("styleBits",
                                           function()this.__scimoz.styleBits);
koSciMozWrapper.prototype.__defineGetter__("autoCSeparator",
                                           function()this.__scimoz.autoCSeparator);
koSciMozWrapper.prototype.__defineGetter__("caretPeriod",
                                           function()this.__scimoz.caretPeriod);
koSciMozWrapper.prototype.__defineGetter__("characterPointer",
                                           function()this.__scimoz.characterPointer);
koSciMozWrapper.prototype.__defineGetter__("marginStyleOffset",
                                           function()this.__scimoz.marginStyleOffset);
koSciMozWrapper.prototype.__defineGetter__("modify",
                                           function()this.__scimoz.modify);
koSciMozWrapper.prototype.__defineGetter__("multiPaste",
                                           function()this.__scimoz.multiPaste);
koSciMozWrapper.prototype.__defineGetter__("targetEnd",
                                           function()this.__scimoz.targetEnd);
koSciMozWrapper.prototype.__defineGetter__("modEventMask",
                                           function()this.__scimoz.modEventMask);
koSciMozWrapper.prototype.__defineGetter__("additionalCaretFore",
                                           function()this.__scimoz.additionalCaretFore);
koSciMozWrapper.prototype.__defineGetter__("autoCDropRestOfWord",
                                           function()this.__scimoz.autoCDropRestOfWord);
koSciMozWrapper.prototype.__defineGetter__("searchFlags",
                                           function()this.__scimoz.searchFlags);
koSciMozWrapper.prototype.__defineGetter__("positionCache",
                                           function()this.__scimoz.positionCache);
koSciMozWrapper.prototype.__defineGetter__("caretWidth",
                                           function()this.__scimoz.caretWidth);
koSciMozWrapper.prototype.__defineGetter__("indent",
                                           function()this.__scimoz.indent);
koSciMozWrapper.prototype.__defineGetter__("additionalSelAlpha",
                                           function()this.__scimoz.additionalSelAlpha);
koSciMozWrapper.prototype.__defineGetter__("textLength",
                                           function()this.__scimoz.textLength);
koSciMozWrapper.prototype.__defineGetter__("currentPos",
                                           function()this.__scimoz.currentPos);
koSciMozWrapper.prototype.__defineGetter__("autoCTypeSeparator",
                                           function()this.__scimoz.autoCTypeSeparator);
koSciMozWrapper.prototype.__defineGetter__("selAlpha",
                                           function()this.__scimoz.selAlpha);
koSciMozWrapper.prototype.__defineGetter__("length",
                                           function()this.__scimoz.length);
koSciMozWrapper.prototype.__defineGetter__("caretLineBack",
                                           function()this.__scimoz.caretLineBack);
koSciMozWrapper.prototype.__defineGetter__("rectangularSelectionCaret",
                                           function()this.__scimoz.rectangularSelectionCaret);
koSciMozWrapper.prototype.__defineGetter__("isOwned",
                                           function()this.__scimoz.isOwned);
koSciMozWrapper.prototype.__defineGetter__("visible",
                                           function()this.__scimoz.visible);
koSciMozWrapper.prototype.__defineGetter__("lineCount",
                                           function()this.__scimoz.lineCount);
koSciMozWrapper.prototype.__defineGetter__("selectionEnd",
                                           function()this.__scimoz.selectionEnd);
koSciMozWrapper.prototype.__defineGetter__("tabIndents",
                                           function()this.__scimoz.tabIndents);
koSciMozWrapper.prototype.__defineGetter__("scrollWidth",
                                           function()this.__scimoz.scrollWidth);
koSciMozWrapper.prototype.__defineGetter__("wrapVisualFlagsLocation",
                                           function()this.__scimoz.wrapVisualFlagsLocation);
koSciMozWrapper.prototype.__defineGetter__("printWrapMode",
                                           function()this.__scimoz.printWrapMode);
koSciMozWrapper.prototype.__defineGetter__("indicatorCurrent",
                                           function()this.__scimoz.indicatorCurrent);
koSciMozWrapper.prototype.__defineGetter__("additionalCaretsVisible",
                                           function()this.__scimoz.additionalCaretsVisible);
koSciMozWrapper.prototype.__defineGetter__("fontQuality",
                                           function()this.__scimoz.fontQuality);
koSciMozWrapper.prototype.__defineGetter__("printMagnification",
                                           function()this.__scimoz.printMagnification);
koSciMozWrapper.prototype.__defineGetter__("wrapMode",
                                           function()this.__scimoz.wrapMode);
koSciMozWrapper.prototype.__defineGetter__("isTracking",
                                           function()this.__scimoz.isTracking);
koSciMozWrapper.prototype.__defineGetter__("extraAscent",
                                           function()this.__scimoz.extraAscent);
koSciMozWrapper.prototype.__defineGetter__("scrollWidthTracking",
                                           function()this.__scimoz.scrollWidthTracking);
koSciMozWrapper.prototype.__defineGetter__("targetStart",
                                           function()this.__scimoz.targetStart);
koSciMozWrapper.prototype.__defineGetter__("dragPosition",
                                           function()this.__scimoz.dragPosition);
koSciMozWrapper.prototype.__defineGetter__("layoutCache",
                                           function()this.__scimoz.layoutCache);
koSciMozWrapper.prototype.__defineGetter__("controlCharSymbol",
                                           function()this.__scimoz.controlCharSymbol);
koSciMozWrapper.prototype.__defineGetter__("styleBitsNeeded",
                                           function()this.__scimoz.styleBitsNeeded);
koSciMozWrapper.prototype.__defineGetter__("caretLineBackAlpha",
                                           function()this.__scimoz.caretLineBackAlpha);
koSciMozWrapper.prototype.__defineGetter__("selectionMode",
                                           function()this.__scimoz.selectionMode);
koSciMozWrapper.prototype.__defineGetter__("marginOptions",
                                           function()this.__scimoz.marginOptions);
koSciMozWrapper.prototype.__defineGetter__("autoCMaxWidth",
                                           function()this.__scimoz.autoCMaxWidth);
koSciMozWrapper.prototype.__defineGetter__("mouseDwellTime",
                                           function()this.__scimoz.mouseDwellTime);
koSciMozWrapper.prototype.__defineGetter__("inDragSession",
                                           function()this.__scimoz.inDragSession);
koSciMozWrapper.prototype.__defineGetter__("rectangularSelectionModifier",
                                           function()this.__scimoz.rectangularSelectionModifier);
koSciMozWrapper.prototype.__defineGetter__("viewWS",
                                           function()this.__scimoz.viewWS);
koSciMozWrapper.prototype.__defineGetter__("backSpaceUnIndents",
                                           function()this.__scimoz.backSpaceUnIndents);
koSciMozWrapper.prototype.__defineGetter__("cursor",
                                           function()this.__scimoz.cursor);
koSciMozWrapper.prototype.__defineGetter__("tabWidth",
                                           function()this.__scimoz.tabWidth);
koSciMozWrapper.prototype.__defineGetter__("anchor",
                                           function()this.__scimoz.anchor);
koSciMozWrapper.prototype.__defineGetter__("xOffset",
                                           function()this.__scimoz.xOffset);
koSciMozWrapper.prototype.__defineGetter__("additionalCaretsBlink",
                                           function()this.__scimoz.additionalCaretsBlink);
koSciMozWrapper.prototype.__defineGetter__("additionalSelectionTyping",
                                           function()this.__scimoz.additionalSelectionTyping);
koSciMozWrapper.prototype.__defineGetter__("caretFore",
                                           function()this.__scimoz.caretFore);
koSciMozWrapper.prototype.__defineGetter__("annotationVisible",
                                           function()this.__scimoz.annotationVisible);
koSciMozWrapper.prototype.__defineGetter__("wrapIndentMode",
                                           function()this.__scimoz.wrapIndentMode);
koSciMozWrapper.prototype.__defineGetter__("autoCAutoHide",
                                           function()this.__scimoz.autoCAutoHide);
koSciMozWrapper.prototype.__defineGetter__("marginRight",
                                           function()this.__scimoz.marginRight);
koSciMozWrapper.prototype.__defineGetter__("extraDescent",
                                           function()this.__scimoz.extraDescent);
koSciMozWrapper.prototype.__defineGetter__("caretLineVisible",
                                           function()this.__scimoz.caretLineVisible);
koSciMozWrapper.prototype.__defineGetter__("isFocused",
                                           function()this.__scimoz.isFocused);
koSciMozWrapper.prototype.__defineGetter__("firstVisibleLine",
                                           function()this.__scimoz.firstVisibleLine);
koSciMozWrapper.prototype.__defineGetter__("virtualSpaceOptions",
                                           function()this.__scimoz.virtualSpaceOptions);
koSciMozWrapper.prototype.__defineGetter__("marginLeft",
                                           function()this.__scimoz.marginLeft);
koSciMozWrapper.prototype.__defineGetter__("autoCChooseSingle",
                                           function()this.__scimoz.autoCChooseSingle);
koSciMozWrapper.prototype.__defineGetter__("rectangularSelectionCaretVirtualSpace",
                                           function()this.__scimoz.rectangularSelectionCaretVirtualSpace);
koSciMozWrapper.prototype.__defineGetter__("status",
                                           function()this.__scimoz.status);
koSciMozWrapper.prototype.__defineGetter__("eOLMode",
                                           function()this.__scimoz.eOLMode);
koSciMozWrapper.prototype.__defineGetter__("edgeMode",
                                           function()this.__scimoz.edgeMode);
koSciMozWrapper.prototype.__defineGetter__("docPointer",
                                           function()this.__scimoz.docPointer);
koSciMozWrapper.prototype.__defineGetter__("caretSticky",
                                           function()this.__scimoz.caretSticky);
koSciMozWrapper.prototype.__defineGetter__("maxLineState",
                                           function()this.__scimoz.maxLineState);
koSciMozWrapper.prototype.__defineGetter__("usePalette",
                                           function()this.__scimoz.usePalette);
koSciMozWrapper.prototype.__defineGetter__("linesOnScreen",
                                           function()this.__scimoz.linesOnScreen);
koSciMozWrapper.prototype.__defineGetter__("pasteConvertEndings",
                                           function()this.__scimoz.pasteConvertEndings);
koSciMozWrapper.prototype.__defineGetter__("caretStyle",
                                           function()this.__scimoz.caretStyle);
koSciMozWrapper.prototype.__defineGetter__("mouseDownCaptures",
                                           function()this.__scimoz.mouseDownCaptures);
koSciMozWrapper.prototype.__defineSetter__("highlightGuide",
                                           function(v)this.__scimoz.highlightGuide=v);
koSciMozWrapper.prototype.__defineSetter__("edgeColumn",
                                           function(v)this.__scimoz.edgeColumn=v);
koSciMozWrapper.prototype.__defineSetter__("twoPhaseDraw",
                                           function(v)this.__scimoz.twoPhaseDraw=v);
koSciMozWrapper.prototype.__defineSetter__("focus",
                                           function(v)this.__scimoz.focus=v);
koSciMozWrapper.prototype.__defineSetter__("autoCMaxHeight",
                                           function(v)this.__scimoz.autoCMaxHeight=v);
koSciMozWrapper.prototype.__defineSetter__("autoCCancelAtStart",
                                           function(v)this.__scimoz.autoCCancelAtStart=v);
koSciMozWrapper.prototype.__defineSetter__("rectangularSelectionAnchor",
                                           function(v)this.__scimoz.rectangularSelectionAnchor=v);
koSciMozWrapper.prototype.__defineSetter__("multipleSelection",
                                           function(v)this.__scimoz.multipleSelection=v);
koSciMozWrapper.prototype.__defineSetter__("indicatorValue",
                                           function(v)this.__scimoz.indicatorValue=v);
koSciMozWrapper.prototype.__defineSetter__("text",
                                           function(v)this.__scimoz.text=v);
koSciMozWrapper.prototype.__defineSetter__("annotationStyleOffset",
                                           function(v)this.__scimoz.annotationStyleOffset=v);
koSciMozWrapper.prototype.__defineSetter__("bufferedDraw",
                                           function(v)this.__scimoz.bufferedDraw=v);
koSciMozWrapper.prototype.__defineSetter__("whitespaceSize",
                                           function(v)this.__scimoz.whitespaceSize=v);
koSciMozWrapper.prototype.__defineSetter__("hScrollBar",
                                           function(v)this.__scimoz.hScrollBar=v);
koSciMozWrapper.prototype.__defineSetter__("readOnly",
                                           function(v)this.__scimoz.readOnly=v);
koSciMozWrapper.prototype.__defineSetter__("keysUnicode",
                                           function(v)this.__scimoz.keysUnicode=v);
koSciMozWrapper.prototype.__defineSetter__("selEOLFilled",
                                           function(v)this.__scimoz.selEOLFilled=v);
koSciMozWrapper.prototype.__defineSetter__("name",
                                           function(v)this.__scimoz.name=v);
koSciMozWrapper.prototype.__defineSetter__("overtype",
                                           function(v)this.__scimoz.overtype=v);
koSciMozWrapper.prototype.__defineSetter__("lexer",
                                           function(v)this.__scimoz.lexer=v);
koSciMozWrapper.prototype.__defineSetter__("codePage",
                                           function(v)this.__scimoz.codePage=v);
koSciMozWrapper.prototype.__defineSetter__("zoom",
                                           function(v)this.__scimoz.zoom=v);
koSciMozWrapper.prototype.__defineSetter__("rectangularSelectionAnchorVirtualSpace",
                                           function(v)this.__scimoz.rectangularSelectionAnchorVirtualSpace=v);
koSciMozWrapper.prototype.__defineSetter__("indentationGuides",
                                           function(v)this.__scimoz.indentationGuides=v);
koSciMozWrapper.prototype.__defineSetter__("identifier",
                                           function(v)this.__scimoz.identifier=v);
koSciMozWrapper.prototype.__defineSetter__("useTabs",
                                           function(v)this.__scimoz.useTabs=v);
koSciMozWrapper.prototype.__defineSetter__("printColourMode",
                                           function(v)this.__scimoz.printColourMode=v);
koSciMozWrapper.prototype.__defineSetter__("hotspotSingleLine",
                                           function(v)this.__scimoz.hotspotSingleLine=v);
koSciMozWrapper.prototype.__defineSetter__("vScrollBar",
                                           function(v)this.__scimoz.vScrollBar=v);
koSciMozWrapper.prototype.__defineSetter__("autoCIgnoreCase",
                                           function(v)this.__scimoz.autoCIgnoreCase=v);
koSciMozWrapper.prototype.__defineSetter__("endAtLastLine",
                                           function(v)this.__scimoz.endAtLastLine=v);
koSciMozWrapper.prototype.__defineSetter__("mainSelection",
                                           function(v)this.__scimoz.mainSelection=v);
koSciMozWrapper.prototype.__defineSetter__("selectionStart",
                                           function(v)this.__scimoz.selectionStart=v);
koSciMozWrapper.prototype.__defineSetter__("wrapStartIndent",
                                           function(v)this.__scimoz.wrapStartIndent=v);
koSciMozWrapper.prototype.__defineSetter__("undoCollection",
                                           function(v)this.__scimoz.undoCollection=v);
koSciMozWrapper.prototype.__defineSetter__("viewEOL",
                                           function(v)this.__scimoz.viewEOL=v);
koSciMozWrapper.prototype.__defineSetter__("edgeColour",
                                           function(v)this.__scimoz.edgeColour=v);
koSciMozWrapper.prototype.__defineSetter__("wrapVisualFlags",
                                           function(v)this.__scimoz.wrapVisualFlags=v);
koSciMozWrapper.prototype.__defineSetter__("styleBits",
                                           function(v)this.__scimoz.styleBits=v);
koSciMozWrapper.prototype.__defineSetter__("autoCSeparator",
                                           function(v)this.__scimoz.autoCSeparator=v);
koSciMozWrapper.prototype.__defineSetter__("caretPeriod",
                                           function(v)this.__scimoz.caretPeriod=v);
koSciMozWrapper.prototype.__defineSetter__("marginStyleOffset",
                                           function(v)this.__scimoz.marginStyleOffset=v);
koSciMozWrapper.prototype.__defineSetter__("multiPaste",
                                           function(v)this.__scimoz.multiPaste=v);
koSciMozWrapper.prototype.__defineSetter__("targetEnd",
                                           function(v)this.__scimoz.targetEnd=v);
koSciMozWrapper.prototype.__defineSetter__("modEventMask",
                                           function(v)this.__scimoz.modEventMask=v);
koSciMozWrapper.prototype.__defineSetter__("additionalCaretFore",
                                           function(v)this.__scimoz.additionalCaretFore=v);
koSciMozWrapper.prototype.__defineSetter__("autoCDropRestOfWord",
                                           function(v)this.__scimoz.autoCDropRestOfWord=v);
koSciMozWrapper.prototype.__defineSetter__("searchFlags",
                                           function(v)this.__scimoz.searchFlags=v);
koSciMozWrapper.prototype.__defineSetter__("positionCache",
                                           function(v)this.__scimoz.positionCache=v);
koSciMozWrapper.prototype.__defineSetter__("caretWidth",
                                           function(v)this.__scimoz.caretWidth=v);
koSciMozWrapper.prototype.__defineSetter__("indent",
                                           function(v)this.__scimoz.indent=v);
koSciMozWrapper.prototype.__defineSetter__("additionalSelAlpha",
                                           function(v)this.__scimoz.additionalSelAlpha=v);
koSciMozWrapper.prototype.__defineSetter__("viewWS",
                                           function(v)this.__scimoz.viewWS=v);
koSciMozWrapper.prototype.__defineSetter__("currentPos",
                                           function(v)this.__scimoz.currentPos=v);
koSciMozWrapper.prototype.__defineSetter__("autoCTypeSeparator",
                                           function(v)this.__scimoz.autoCTypeSeparator=v);
koSciMozWrapper.prototype.__defineSetter__("selAlpha",
                                           function(v)this.__scimoz.selAlpha=v);
koSciMozWrapper.prototype.__defineSetter__("isFocused",
                                           function(v)this.__scimoz.isFocused=v);
koSciMozWrapper.prototype.__defineSetter__("caretLineBack",
                                           function(v)this.__scimoz.caretLineBack=v);
koSciMozWrapper.prototype.__defineSetter__("rectangularSelectionCaret",
                                           function(v)this.__scimoz.rectangularSelectionCaret=v);
koSciMozWrapper.prototype.__defineSetter__("visible",
                                           function(v)this.__scimoz.visible=v);
koSciMozWrapper.prototype.__defineSetter__("selectionEnd",
                                           function(v)this.__scimoz.selectionEnd=v);
koSciMozWrapper.prototype.__defineSetter__("tabIndents",
                                           function(v)this.__scimoz.tabIndents=v);
koSciMozWrapper.prototype.__defineSetter__("scrollWidth",
                                           function(v)this.__scimoz.scrollWidth=v);
koSciMozWrapper.prototype.__defineSetter__("wrapVisualFlagsLocation",
                                           function(v)this.__scimoz.wrapVisualFlagsLocation=v);
koSciMozWrapper.prototype.__defineSetter__("printWrapMode",
                                           function(v)this.__scimoz.printWrapMode=v);
koSciMozWrapper.prototype.__defineSetter__("indicatorCurrent",
                                           function(v)this.__scimoz.indicatorCurrent=v);
koSciMozWrapper.prototype.__defineSetter__("additionalCaretsVisible",
                                           function(v)this.__scimoz.additionalCaretsVisible=v);
koSciMozWrapper.prototype.__defineSetter__("fontQuality",
                                           function(v)this.__scimoz.fontQuality=v);
koSciMozWrapper.prototype.__defineSetter__("printMagnification",
                                           function(v)this.__scimoz.printMagnification=v);
koSciMozWrapper.prototype.__defineSetter__("wrapMode",
                                           function(v)this.__scimoz.wrapMode=v);
koSciMozWrapper.prototype.__defineSetter__("extraAscent",
                                           function(v)this.__scimoz.extraAscent=v);
koSciMozWrapper.prototype.__defineSetter__("scrollWidthTracking",
                                           function(v)this.__scimoz.scrollWidthTracking=v);
koSciMozWrapper.prototype.__defineSetter__("targetStart",
                                           function(v)this.__scimoz.targetStart=v);
koSciMozWrapper.prototype.__defineSetter__("dragPosition",
                                           function(v)this.__scimoz.dragPosition=v);
koSciMozWrapper.prototype.__defineSetter__("layoutCache",
                                           function(v)this.__scimoz.layoutCache=v);
koSciMozWrapper.prototype.__defineSetter__("controlCharSymbol",
                                           function(v)this.__scimoz.controlCharSymbol=v);
koSciMozWrapper.prototype.__defineSetter__("usePalette",
                                           function(v)this.__scimoz.usePalette=v);
koSciMozWrapper.prototype.__defineSetter__("selectionMode",
                                           function(v)this.__scimoz.selectionMode=v);
koSciMozWrapper.prototype.__defineSetter__("marginOptions",
                                           function(v)this.__scimoz.marginOptions=v);
koSciMozWrapper.prototype.__defineSetter__("autoCMaxWidth",
                                           function(v)this.__scimoz.autoCMaxWidth=v);
koSciMozWrapper.prototype.__defineSetter__("mouseDwellTime",
                                           function(v)this.__scimoz.mouseDwellTime=v);
koSciMozWrapper.prototype.__defineSetter__("rectangularSelectionModifier",
                                           function(v)this.__scimoz.rectangularSelectionModifier=v);
koSciMozWrapper.prototype.__defineSetter__("backSpaceUnIndents",
                                           function(v)this.__scimoz.backSpaceUnIndents=v);
koSciMozWrapper.prototype.__defineSetter__("cursor",
                                           function(v)this.__scimoz.cursor=v);
koSciMozWrapper.prototype.__defineSetter__("tabWidth",
                                           function(v)this.__scimoz.tabWidth=v);
koSciMozWrapper.prototype.__defineSetter__("anchor",
                                           function(v)this.__scimoz.anchor=v);
koSciMozWrapper.prototype.__defineSetter__("xOffset",
                                           function(v)this.__scimoz.xOffset=v);
koSciMozWrapper.prototype.__defineSetter__("additionalCaretsBlink",
                                           function(v)this.__scimoz.additionalCaretsBlink=v);
koSciMozWrapper.prototype.__defineSetter__("additionalSelectionTyping",
                                           function(v)this.__scimoz.additionalSelectionTyping=v);
koSciMozWrapper.prototype.__defineSetter__("caretFore",
                                           function(v)this.__scimoz.caretFore=v);
koSciMozWrapper.prototype.__defineSetter__("annotationVisible",
                                           function(v)this.__scimoz.annotationVisible=v);
koSciMozWrapper.prototype.__defineSetter__("wrapIndentMode",
                                           function(v)this.__scimoz.wrapIndentMode=v);
koSciMozWrapper.prototype.__defineSetter__("autoCAutoHide",
                                           function(v)this.__scimoz.autoCAutoHide=v);
koSciMozWrapper.prototype.__defineSetter__("marginRight",
                                           function(v)this.__scimoz.marginRight=v);
koSciMozWrapper.prototype.__defineSetter__("extraDescent",
                                           function(v)this.__scimoz.extraDescent=v);
koSciMozWrapper.prototype.__defineSetter__("caretLineVisible",
                                           function(v)this.__scimoz.caretLineVisible=v);
koSciMozWrapper.prototype.__defineSetter__("firstVisibleLine",
                                           function(v)this.__scimoz.firstVisibleLine=v);
koSciMozWrapper.prototype.__defineSetter__("virtualSpaceOptions",
                                           function(v)this.__scimoz.virtualSpaceOptions=v);
koSciMozWrapper.prototype.__defineSetter__("marginLeft",
                                           function(v)this.__scimoz.marginLeft=v);
koSciMozWrapper.prototype.__defineSetter__("autoCChooseSingle",
                                           function(v)this.__scimoz.autoCChooseSingle=v);
koSciMozWrapper.prototype.__defineSetter__("rectangularSelectionCaretVirtualSpace",
                                           function(v)this.__scimoz.rectangularSelectionCaretVirtualSpace=v);
koSciMozWrapper.prototype.__defineSetter__("status",
                                           function(v)this.__scimoz.status=v);
koSciMozWrapper.prototype.__defineSetter__("eOLMode",
                                           function(v)this.__scimoz.eOLMode=v);
koSciMozWrapper.prototype.__defineSetter__("edgeMode",
                                           function(v)this.__scimoz.edgeMode=v);
koSciMozWrapper.prototype.__defineSetter__("docPointer",
                                           function(v)this.__scimoz.docPointer=v);
koSciMozWrapper.prototype.__defineSetter__("caretSticky",
                                           function(v)this.__scimoz.caretSticky=v);
koSciMozWrapper.prototype.__defineSetter__("caretLineBackAlpha",
                                           function(v)this.__scimoz.caretLineBackAlpha=v);
koSciMozWrapper.prototype.__defineSetter__("pasteConvertEndings",
                                           function(v)this.__scimoz.pasteConvertEndings=v);
koSciMozWrapper.prototype.__defineSetter__("caretStyle",
                                           function(v)this.__scimoz.caretStyle=v);
koSciMozWrapper.prototype.__defineSetter__("mouseDownCaptures",
                                           function(v)this.__scimoz.mouseDownCaptures=v);
koSciMozWrapper.prototype.vCHomeWrapExtend =
    function() this.__scimoz.vCHomeWrapExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setMarginMaskN =
    function() this.__scimoz.setMarginMaskN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.homeWrapExtend =
    function() this.__scimoz.homeWrapExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.marginSetStyles =
    function() this.__scimoz.marginSetStyles.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelectionNEnd =
    function() this.__scimoz.setSelectionNEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLineState =
    function() this.__scimoz.getLineState.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.init =
    function() this.__scimoz.init.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.toggleCaretSticky =
    function() this.__scimoz.toggleCaretSticky.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setAdditionalSelFore =
    function() this.__scimoz.setAdditionalSelFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipSetBack =
    function() this.__scimoz.callTipSetBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.positionAfter =
    function() this.__scimoz.positionAfter.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.stopRecord =
    function() this.__scimoz.stopRecord.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetBold =
    function() this.__scimoz.styleGetBold.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.buttonMove =
    function() this.__scimoz.buttonMove.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setMarginCursorN =
    function() this.__scimoz.setMarginCursorN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getTag =
    function() this.__scimoz.getTag.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getSelectionNCaret =
    function() this.__scimoz.getSelectionNCaret.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.moveSelectedLinesUp =
    function() this.__scimoz.moveSelectedLinesUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.rotateSelection =
    function() this.__scimoz.rotateSelection.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicatorValueAt =
    function() this.__scimoz.indicatorValueAt.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicatorStart =
    function() this.__scimoz.indicatorStart.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setFoldMarginHiColour =
    function() this.__scimoz.setFoldMarginHiColour.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordStartPosition =
    function() this.__scimoz.wordStartPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationGetLines =
    function() this.__scimoz.annotationGetLines.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.copyRange =
    function() this.__scimoz.copyRange.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.buttonDown =
    function() this.__scimoz.buttonDown.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.findColumn =
    function() this.__scimoz.findColumn.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetEOLFilled =
    function() this.__scimoz.styleSetEOLFilled.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.showLines =
    function() this.__scimoz.showLines.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.textWidth =
    function() this.__scimoz.textWidth.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerGet =
    function() this.__scimoz.markerGet.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.clearSelections =
    function() this.__scimoz.clearSelections.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getMarginSensitiveN =
    function() this.__scimoz.getMarginSensitiveN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerSetBackSelected =
    function() this.__scimoz.markerSetBackSelected.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCSetFillUps =
    function() this.__scimoz.autoCSetFillUps.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.releaseMouseCapture =
    function() this.__scimoz.releaseMouseCapture.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.describeKeyWordSets =
    function() this.__scimoz.describeKeyWordSets.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.positionFromPointClose =
    function() this.__scimoz.positionFromPointClose.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.braceBadLightIndicator =
    function() this.__scimoz.braceBadLightIndicator.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.convertEOLs =
    function() this.__scimoz.convertEOLs.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.upperCase =
    function() this.__scimoz.upperCase.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordPartLeft =
    function() this.__scimoz.wordPartLeft.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getHotspotActiveBack =
    function() this.__scimoz.getHotspotActiveBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.formFeed =
    function() this.__scimoz.formFeed.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetCharacterSet =
    function() this.__scimoz.styleGetCharacterSet.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerDefine =
    function() this.__scimoz.markerDefine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.selectAll =
    function() this.__scimoz.selectAll.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.visibleFromDocLine =
    function() this.__scimoz.visibleFromDocLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.braceHighlightIndicator =
    function() this.__scimoz.braceHighlightIndicator.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetFore =
    function() this.__scimoz.styleGetFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.propertyNames =
    function() this.__scimoz.propertyNames.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLineIndentPosition =
    function() this.__scimoz.getLineIndentPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.usePopUp =
    function() this.__scimoz.usePopUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLineSelStartPosition =
    function() this.__scimoz.getLineSelStartPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicSetUnder =
    function() this.__scimoz.indicSetUnder.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelectionNCaretVirtualSpace =
    function() this.__scimoz.setSelectionNCaretVirtualSpace.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.delLineRight =
    function() this.__scimoz.delLineRight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.homeDisplayExtend =
    function() this.__scimoz.homeDisplayExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setCommandUpdateTarget =
    function() this.__scimoz.setCommandUpdateTarget.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetChangeable =
    function() this.__scimoz.styleGetChangeable.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.describeProperty =
    function() this.__scimoz.describeProperty.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.endDrop =
    function() this.__scimoz.endDrop.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pageDown =
    function() this.__scimoz.pageDown.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.positionBefore =
    function() this.__scimoz.positionBefore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setKeyWords =
    function() this.__scimoz.setKeyWords.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerSetBack =
    function() this.__scimoz.markerSetBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pointXFromPosition =
    function() this.__scimoz.pointXFromPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineUpExtend =
    function() this.__scimoz.lineUpExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicatorAllOnFor =
    function() this.__scimoz.indicatorAllOnFor.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetCharacterSet =
    function() this.__scimoz.styleSetCharacterSet.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicatorFillRange =
    function() this.__scimoz.indicatorFillRange.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.docLineFromVisible =
    function() this.__scimoz.docLineFromVisible.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCGetCurrentText =
    function() this.__scimoz.autoCGetCurrentText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.tab =
    function() this.__scimoz.tab.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getFoldLevel =
    function() this.__scimoz.getFoldLevel.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.deleteBack =
    function() this.__scimoz.deleteBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineEndExtend =
    function() this.__scimoz.lineEndExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCCancel =
    function() this.__scimoz.autoCCancel.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.marginTextClearAll =
    function() this.__scimoz.marginTextClearAll.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.addUndoAction =
    function() this.__scimoz.addUndoAction.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pageUpExtend =
    function() this.__scimoz.pageUpExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.addText =
    function() this.__scimoz.addText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelection =
    function() this.__scimoz.setSelection.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.addRefDocument =
    function() this.__scimoz.addRefDocument.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordPartRight =
    function() this.__scimoz.wordPartRight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.buttonUp =
    function() this.__scimoz.buttonUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.deleteBackNotLine =
    function() this.__scimoz.deleteBackNotLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCPosStart =
    function() this.__scimoz.autoCPosStart.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.stutteredPageDownExtend =
    function() this.__scimoz.stutteredPageDownExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getFoldExpanded =
    function() this.__scimoz.getFoldExpanded.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelBack =
    function() this.__scimoz.setSelBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetBack =
    function() this.__scimoz.styleGetBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charRightExtend =
    function() this.__scimoz.charRightExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.moveSelectedLinesDown =
    function() this.__scimoz.moveSelectedLinesDown.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getStyledText =
    function() this.__scimoz.getStyledText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationGetStyle =
    function() this.__scimoz.annotationGetStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineTranspose =
    function() this.__scimoz.lineTranspose.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipActive =
    function() this.__scimoz.callTipActive.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.documentStartExtend =
    function() this.__scimoz.documentStartExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.marginGetStyle =
    function() this.__scimoz.marginGetStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipShow =
    function() this.__scimoz.callTipShow.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setLengthForEncode =
    function() this.__scimoz.setLengthForEncode.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.unhookEvents =
    function() this.__scimoz.unhookEvents.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getStyleAt =
    function() this.__scimoz.getStyleAt.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineEndDisplayExtend =
    function() this.__scimoz.lineEndDisplayExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetUnderline =
    function() this.__scimoz.styleSetUnderline.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.startRecord =
    function() this.__scimoz.startRecord.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.assignCmdKey =
    function() this.__scimoz.assignCmdKey.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.newLine =
    function() this.__scimoz.newLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerLineFromHandle =
    function() this.__scimoz.markerLineFromHandle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerAdd =
    function() this.__scimoz.markerAdd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.registerImage =
    function() this.__scimoz.registerImage.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getSelectionNAnchor =
    function() this.__scimoz.getSelectionNAnchor.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCComplete =
    function() this.__scimoz.autoCComplete.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.insertText =
    function() this.__scimoz.insertText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setWhitespaceBack =
    function() this.__scimoz.setWhitespaceBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineDownRectExtend =
    function() this.__scimoz.lineDownRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationSetStyles =
    function() this.__scimoz.annotationSetStyles.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charLeft =
    function() this.__scimoz.charLeft.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicGetAlpha =
    function() this.__scimoz.indicGetAlpha.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLine =
    function() this.__scimoz.getLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineLength =
    function() this.__scimoz.lineLength.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetUnderline =
    function() this.__scimoz.styleGetUnderline.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.positionAtColumn =
    function() this.__scimoz.positionAtColumn.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerSetFore =
    function() this.__scimoz.markerSetFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordRightEnd =
    function() this.__scimoz.wordRightEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicSetOutlineAlpha =
    function() this.__scimoz.indicSetOutlineAlpha.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.marginGetText =
    function() this.__scimoz.marginGetText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineEndWrap =
    function() this.__scimoz.lineEndWrap.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setHotspotActiveBack =
    function() this.__scimoz.setHotspotActiveBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.hideSelection =
    function() this.__scimoz.hideSelection.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.undo =
    function() this.__scimoz.undo.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wrapCount =
    function() this.__scimoz.wrapCount.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineEndWrapExtend =
    function() this.__scimoz.lineEndWrapExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.privateLexerCall =
    function() this.__scimoz.privateLexerCall.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getWCharAt =
    function() this.__scimoz.getWCharAt.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordLeftExtend =
    function() this.__scimoz.wordLeftExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setHotspotActiveFore =
    function() this.__scimoz.setHotspotActiveFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerDeleteAll =
    function() this.__scimoz.markerDeleteAll.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getMarginMaskN =
    function() this.__scimoz.getMarginMaskN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineScrollUp =
    function() this.__scimoz.lineScrollUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.swapMainAnchorCaret =
    function() this.__scimoz.swapMainAnchorCaret.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordEndPosition =
    function() this.__scimoz.wordEndPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setFoldMarginColour =
    function() this.__scimoz.setFoldMarginColour.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.gotoLine =
    function() this.__scimoz.gotoLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.hookEvents =
    function() this.__scimoz.hookEvents.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.sendUpdateCommands =
    function() this.__scimoz.sendUpdateCommands.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setLineState =
    function() this.__scimoz.setLineState.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.linesSplit =
    function() this.__scimoz.linesSplit.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.replaceSel =
    function() this.__scimoz.replaceSel.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setHotspotActiveUnderline =
    function() this.__scimoz.setHotspotActiveUnderline.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.ensureVisibleEnforcePolicy =
    function() this.__scimoz.ensureVisibleEnforcePolicy.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerEnableHighlight =
    function() this.__scimoz.markerEnableHighlight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charLeftExtend =
    function() this.__scimoz.charLeftExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markClosed =
    function() this.__scimoz.markClosed.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setXCaretPolicy =
    function() this.__scimoz.setXCaretPolicy.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerSymbolDefined =
    function() this.__scimoz.markerSymbolDefined.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetItalic =
    function() this.__scimoz.styleGetItalic.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setProperty =
    function() this.__scimoz.setProperty.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.copy =
    function() this.__scimoz.copy.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.chooseCaretX =
    function() this.__scimoz.chooseCaretX.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetSize =
    function() this.__scimoz.styleGetSize.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setFoldLevel =
    function() this.__scimoz.setFoldLevel.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.moveCaretInsideView =
    function() this.__scimoz.moveCaretInsideView.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setLexerLanguage =
    function() this.__scimoz.setLexerLanguage.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getSelectionNStart =
    function() this.__scimoz.getSelectionNStart.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetBold =
    function() this.__scimoz.styleSetBold.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicSetStyle =
    function() this.__scimoz.indicSetStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.backTab =
    function() this.__scimoz.backTab.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.releaseDocument =
    function() this.__scimoz.releaseDocument.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.searchInTarget =
    function() this.__scimoz.searchInTarget.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLineSelEndPosition =
    function() this.__scimoz.getLineSelEndPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.addChar =
    function() this.__scimoz.addChar.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pageDownExtend =
    function() this.__scimoz.pageDownExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.null =
    function() this.__scimoz.null.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.emptyUndoBuffer =
    function() this.__scimoz.emptyUndoBuffer.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineCopy =
    function() this.__scimoz.lineCopy.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.linesJoin =
    function() this.__scimoz.linesJoin.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getFoldParent =
    function() this.__scimoz.getFoldParent.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getSelectionNCaretVirtualSpace =
    function() this.__scimoz.getSelectionNCaretVirtualSpace.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.homeExtend =
    function() this.__scimoz.homeExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.homeWrap =
    function() this.__scimoz.homeWrap.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.copyAllowLine =
    function() this.__scimoz.copyAllowLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.clear =
    function() this.__scimoz.clear.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationSetStyle =
    function() this.__scimoz.annotationSetStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordLeft =
    function() this.__scimoz.wordLeft.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.gotoPos =
    function() this.__scimoz.gotoPos.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.marginSetStyle =
    function() this.__scimoz.marginSetStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setYCaretPolicy =
    function() this.__scimoz.setYCaretPolicy.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSavePoint =
    function() this.__scimoz.setSavePoint.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setWhitespaceChars =
    function() this.__scimoz.setWhitespaceChars.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.stutteredPageUpExtend =
    function() this.__scimoz.stutteredPageUpExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getMarginWidthN =
    function() this.__scimoz.getMarginWidthN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerPrevious =
    function() this.__scimoz.markerPrevious.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.marginGetStyles =
    function() this.__scimoz.marginGetStyles.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.documentStart =
    function() this.__scimoz.documentStart.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.delWordRightEnd =
    function() this.__scimoz.delWordRightEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineEnd =
    function() this.__scimoz.lineEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationClearAll =
    function() this.__scimoz.annotationClearAll.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pageUpRectExtend =
    function() this.__scimoz.pageUpRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetItalic =
    function() this.__scimoz.styleSetItalic.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.propertyType =
    function() this.__scimoz.propertyType.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.searchPrev =
    function() this.__scimoz.searchPrev.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.rGBAImageSetWidth =
    function() this.__scimoz.rGBAImageSetWidth.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.homeDisplay =
    function() this.__scimoz.homeDisplay.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerAddSet =
    function() this.__scimoz.markerAddSet.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setMarginWidthN =
    function() this.__scimoz.setMarginWidthN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelectionNAnchor =
    function() this.__scimoz.setSelectionNAnchor.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.vCHomeExtend =
    function() this.__scimoz.vCHomeExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSel =
    function() this.__scimoz.setSel.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetEOLFilled =
    function() this.__scimoz.styleGetEOLFilled.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.delWordLeft =
    function() this.__scimoz.delWordLeft.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.zoomOut =
    function() this.__scimoz.zoomOut.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getMarginCursorN =
    function() this.__scimoz.getMarginCursorN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.paraUp =
    function() this.__scimoz.paraUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.addSelection =
    function() this.__scimoz.addSelection.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.stutteredPageDown =
    function() this.__scimoz.stutteredPageDown.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charPosAtPosition =
    function() this.__scimoz.charPosAtPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipPosStart =
    function() this.__scimoz.callTipPosStart.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationGetStyles =
    function() this.__scimoz.annotationGetStyles.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetCase =
    function() this.__scimoz.styleGetCase.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetHotSpot =
    function() this.__scimoz.styleSetHotSpot.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.paraDown =
    function() this.__scimoz.paraDown.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicSetFore =
    function() this.__scimoz.indicSetFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getCharAt =
    function() this.__scimoz.getCharAt.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.beginUndoAction =
    function() this.__scimoz.beginUndoAction.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineCut =
    function() this.__scimoz.lineCut.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineEndDisplay =
    function() this.__scimoz.lineEndDisplay.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleClearAll =
    function() this.__scimoz.styleClearAll.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleResetDefault =
    function() this.__scimoz.styleResetDefault.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.vCHome =
    function() this.__scimoz.vCHome.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.canRedo =
    function() this.__scimoz.canRedo.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineFromPosition =
    function() this.__scimoz.lineFromPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setVisiblePolicy =
    function() this.__scimoz.setVisiblePolicy.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.loadLexerLibrary =
    function() this.__scimoz.loadLexerLibrary.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.clearAllCmdKeys =
    function() this.__scimoz.clearAllCmdKeys.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.marginSetText =
    function() this.__scimoz.marginSetText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charRight =
    function() this.__scimoz.charRight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setStyling =
    function() this.__scimoz.setStyling.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerSetAlpha =
    function() this.__scimoz.markerSetAlpha.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineEndRectExtend =
    function() this.__scimoz.lineEndRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charLeftRectExtend =
    function() this.__scimoz.charLeftRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.cancel =
    function() this.__scimoz.cancel.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.startStyling =
    function() this.__scimoz.startStyling.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.editToggleOvertype =
    function() this.__scimoz.editToggleOvertype.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.hideLines =
    function() this.__scimoz.hideLines.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.canUndo =
    function() this.__scimoz.canUndo.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationSetText =
    function() this.__scimoz.annotationSetText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setMarginSensitiveN =
    function() this.__scimoz.setMarginSensitiveN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.stopTimers =
    function() this.__scimoz.stopTimers.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.clearCmdKey =
    function() this.__scimoz.clearCmdKey.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineUpRectExtend =
    function() this.__scimoz.lineUpRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.registerRGBAImage =
    function() this.__scimoz.registerRGBAImage.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordLeftEndExtend =
    function() this.__scimoz.wordLeftEndExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.positionAtChar =
    function() this.__scimoz.positionAtChar.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.replaceTarget =
    function() this.__scimoz.replaceTarget.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelectionNCaret =
    function() this.__scimoz.setSelectionNCaret.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetHotSpot =
    function() this.__scimoz.styleGetHotSpot.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetChangeable =
    function() this.__scimoz.styleSetChangeable.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.braceHighlight =
    function() this.__scimoz.braceHighlight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicGetOutlineAlpha =
    function() this.__scimoz.indicGetOutlineAlpha.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetBack =
    function() this.__scimoz.styleSetBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.canPaste =
    function() this.__scimoz.canPaste.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetFont =
    function() this.__scimoz.styleSetFont.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getSelectionNEnd =
    function() this.__scimoz.getSelectionNEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.homeRectExtend =
    function() this.__scimoz.homeRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setFoldFlags =
    function() this.__scimoz.setFoldFlags.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.clearRegisteredImages =
    function() this.__scimoz.clearRegisteredImages.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.delLineLeft =
    function() this.__scimoz.delLineLeft.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.textHeight =
    function() this.__scimoz.textHeight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.encodedFromUTF8 =
    function() this.__scimoz.encodedFromUTF8.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setCharsDefault =
    function() this.__scimoz.setCharsDefault.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCShow =
    function() this.__scimoz.autoCShow.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCActive =
    function() this.__scimoz.autoCActive.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getPropertyExpanded =
    function() this.__scimoz.getPropertyExpanded.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getPropertyInt =
    function() this.__scimoz.getPropertyInt.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setWhitespaceFore =
    function() this.__scimoz.setWhitespaceFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicGetStyle =
    function() this.__scimoz.indicGetStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getMarginTypeN =
    function() this.__scimoz.getMarginTypeN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.vCHomeWrap =
    function() this.__scimoz.vCHomeWrap.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.endUndoAction =
    function() this.__scimoz.endUndoAction.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetFore =
    function() this.__scimoz.styleSetFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLastChild =
    function() this.__scimoz.getLastChild.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.delWordRight =
    function() this.__scimoz.delWordRight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerDefinePixmap =
    function() this.__scimoz.markerDefinePixmap.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerDefineRGBAImage =
    function() this.__scimoz.markerDefineRGBAImage.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerDelete =
    function() this.__scimoz.markerDelete.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicatorEnd =
    function() this.__scimoz.indicatorEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.annotationGetText =
    function() this.__scimoz.annotationGetText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordPartLeftExtend =
    function() this.__scimoz.wordPartLeftExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.replaceTargetRE =
    function() this.__scimoz.replaceTargetRE.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordRightExtend =
    function() this.__scimoz.wordRightExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.userListShow =
    function() this.__scimoz.userListShow.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineDown =
    function() this.__scimoz.lineDown.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setWordChars =
    function() this.__scimoz.setWordChars.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getCurLine =
    function() this.__scimoz.getCurLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.targetAsUTF8 =
    function() this.__scimoz.targetAsUTF8.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getHotspotActiveUnderline =
    function() this.__scimoz.getHotspotActiveUnderline.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.contractedFoldNext =
    function() this.__scimoz.contractedFoldNext.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCStops =
    function() this.__scimoz.autoCStops.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicGetUnder =
    function() this.__scimoz.indicGetUnder.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCGetCurrent =
    function() this.__scimoz.autoCGetCurrent.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipSetForeHlt =
    function() this.__scimoz.callTipSetForeHlt.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.autoCSelect =
    function() this.__scimoz.autoCSelect.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.cut =
    function() this.__scimoz.cut.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setStylingEx =
    function() this.__scimoz.setStylingEx.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.rGBAImageSetHeight =
    function() this.__scimoz.rGBAImageSetHeight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setEmptySelection =
    function() this.__scimoz.setEmptySelection.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelectionNAnchorVirtualSpace =
    function() this.__scimoz.setSelectionNAnchorVirtualSpace.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.appendText =
    function() this.__scimoz.appendText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetFont =
    function() this.__scimoz.styleGetFont.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.selectionDuplicate =
    function() this.__scimoz.selectionDuplicate.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setMarginTypeN =
    function() this.__scimoz.setMarginTypeN.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipSetHlt =
    function() this.__scimoz.callTipSetHlt.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.clearDocumentStyle =
    function() this.__scimoz.clearDocumentStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.scrollCaret =
    function() this.__scimoz.scrollCaret.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordPartRightExtend =
    function() this.__scimoz.wordPartRightExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.verticalCentreCaret =
    function() this.__scimoz.verticalCentreCaret.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.searchNext =
    function() this.__scimoz.searchNext.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.braceMatch =
    function() this.__scimoz.braceMatch.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicGetFore =
    function() this.__scimoz.indicGetFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charPositionFromPointClose =
    function() this.__scimoz.charPositionFromPointClose.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charRightRectExtend =
    function() this.__scimoz.charRightRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.clearAll =
    function() this.__scimoz.clearAll.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.zoomIn =
    function() this.__scimoz.zoomIn.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.createDocument =
    function() this.__scimoz.createDocument.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.positionFromPoint =
    function() this.__scimoz.positionFromPoint.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.home =
    function() this.__scimoz.home.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.positionFromLine =
    function() this.__scimoz.positionFromLine.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.toggleFold =
    function() this.__scimoz.toggleFold.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.redo =
    function() this.__scimoz.redo.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetSize =
    function() this.__scimoz.styleSetSize.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.changeLexerState =
    function() this.__scimoz.changeLexerState.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLineIndentation =
    function() this.__scimoz.getLineIndentation.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerDeleteHandle =
    function() this.__scimoz.markerDeleteHandle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipUseStyle =
    function() this.__scimoz.callTipUseStyle.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.allocate =
    function() this.__scimoz.allocate.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getSelectionNAnchorVirtualSpace =
    function() this.__scimoz.getSelectionNAnchorVirtualSpace.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordRightEndExtend =
    function() this.__scimoz.wordRightEndExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.scrollToStart =
    function() this.__scimoz.scrollToStart.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.paste =
    function() this.__scimoz.paste.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.colourise =
    function() this.__scimoz.colourise.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelFore =
    function() this.__scimoz.setSelFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.charPositionFromPoint =
    function() this.__scimoz.charPositionFromPoint.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lowerCase =
    function() this.__scimoz.lowerCase.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getColumn =
    function() this.__scimoz.getColumn.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.braceBadLight =
    function() this.__scimoz.braceBadLight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pageUp =
    function() this.__scimoz.pageUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineDelete =
    function() this.__scimoz.lineDelete.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.paraUpExtend =
    function() this.__scimoz.paraUpExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.grabFocus =
    function() this.__scimoz.grabFocus.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetCase =
    function() this.__scimoz.styleSetCase.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLexerLanguage =
    function() this.__scimoz.getLexerLanguage.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pageDownRectExtend =
    function() this.__scimoz.pageDownRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.doBraceMatch =
    function() this.__scimoz.doBraceMatch.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setFoldExpanded =
    function() this.__scimoz.setFoldExpanded.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.addStyledText =
    function() this.__scimoz.addStyledText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleSetVisible =
    function() this.__scimoz.styleSetVisible.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineScroll =
    function() this.__scimoz.lineScroll.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.vCHomeRectExtend =
    function() this.__scimoz.vCHomeRectExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineUp =
    function() this.__scimoz.lineUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getProperty =
    function() this.__scimoz.getProperty.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.targetFromSelection =
    function() this.__scimoz.targetFromSelection.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineDuplicate =
    function() this.__scimoz.lineDuplicate.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setSelectionNStart =
    function() this.__scimoz.setSelectionNStart.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipCancel =
    function() this.__scimoz.callTipCancel.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineScrollDown =
    function() this.__scimoz.lineScrollDown.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.paraDownExtend =
    function() this.__scimoz.paraDownExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.documentEndExtend =
    function() this.__scimoz.documentEndExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.scrollToEnd =
    function() this.__scimoz.scrollToEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordRight =
    function() this.__scimoz.wordRight.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.searchAnchor =
    function() this.__scimoz.searchAnchor.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setLineIndentation =
    function() this.__scimoz.setLineIndentation.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.lineDownExtend =
    function() this.__scimoz.lineDownExtend.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.styleGetVisible =
    function() this.__scimoz.styleGetVisible.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.stutteredPageUp =
    function() this.__scimoz.stutteredPageUp.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicatorClearRange =
    function() this.__scimoz.indicatorClearRange.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.copyText =
    function() this.__scimoz.copyText.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.setAdditionalSelBack =
    function() this.__scimoz.setAdditionalSelBack.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.documentEnd =
    function() this.__scimoz.documentEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.pointYFromPosition =
    function() this.__scimoz.pointYFromPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.indicSetAlpha =
    function() this.__scimoz.indicSetAlpha.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.callTipSetFore =
    function() this.__scimoz.callTipSetFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getTextRange =
    function() this.__scimoz.getTextRange.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getHotspotActiveFore =
    function() this.__scimoz.getHotspotActiveFore.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLineEndPosition =
    function() this.__scimoz.getLineEndPosition.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.markerNext =
    function() this.__scimoz.markerNext.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.getLineVisible =
    function() this.__scimoz.getLineVisible.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.wordLeftEnd =
    function() this.__scimoz.wordLeftEnd.apply(this.__scimoz, arguments);
koSciMozWrapper.prototype.ensureVisible =
    function() this.__scimoz.ensureVisible.apply(this.__scimoz, arguments);


// implement QI. This needs to happen after the generated code because that
// determines which interfaces to support (due to the _Part? interfaces).
koSciMozWrapper.prototype.QueryInterface =
    XPCOMUtils.generateQI(koSciMozWrapper.prototype._interfaces);

// Override handleTextEvent, since we use the IME helper for that
koSciMozWrapper.prototype.handleTextEvent =
    function handleTextEvent(aEvent, aBoxObject) {
        return this._IMEHelper.handleTextEvent(aEvent, aBoxObject);
    };

/**
 * Initialize the plugin wrapper.
 * @param aPlugin the plugin to wrap
 * @note This isn't an interface method; also, it overrides the stub version
 *       because that does the wrong thing completely (we don't want to just
 *       pass everything to the plugin).
 */
koSciMozWrapper.prototype.init =
    function koSciMozWrapper_init(aPlugin, aFocusElement) {
        this.__scimoz = aPlugin;
        this._IMEHelper =
            Components.classes["@activestate.com/koSciMozIMEHelper;1"]
                       .createInstance(Components.interfaces.koISciMozIMEHelper);
        this._IMEHelper.init(this, aFocusElement);
        this.__scimoz.init(this._IMEHelper);
    };

// XPCOM registration of class.
var components = [koSciMozWrapper];
const NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
